{Aluno: Gustavo Sverzut Barbieri      RA:008849}
{Prof.: Arnaldo                                }
{Lab..: 06                                     }

program complexos;

{ Menu de opcoes                                                                                            }
{     = n a b    - Atribui ao n-simo nmero complexo o valor (a,b);                                        }
{     p n        - Imprime o n-simo nmero no formato especificado;                                        }
{     a n        - Calcula o argumento do n-simo nmero e o imprime, em radianos;                          }
{     | n        - Calcula o mdulo do n-simo nmero e o imprime;                                          }
{     + x y z    - Calcula a soma do x-simo e y-simo nmeros e atribui este valor ao z-simo;             }
{     - x y z    - Calcula a diferena entre o x-simo e o y-simo nmeros e atribui este valor ao z-simo; }
{     * x y z    - Calcula o produto entre o x-simo e o y-simo nmeros e atribui este valor ao z-simo;   }
{     / x y z    - Calcula o quociente do x-simo pelo y-simo nmeros e atribui este valor ao z-simo;     }
{     ! x y      - Calcula o conjugado do x-simo nmero e atribui este valor ao y-simo;                   }
{     e x y      - Calcula exp() do x-simo nmero e atribui este valor ao y-simo;                         }
{     x                                                                                                     }

const pi = 3.1415926;

type
   complexo = array[1..2] of real;

var	   
   numero : array[1..10] of complexo;
   opcao  : char;

{% Funcoes e Procedimentos %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}



procedure atribui;
var n : integer; {recebe a posicao que deve ser colocado o numero lido}
begin
   read(n);
   read(numero[n][1],numero[n][2]);
end; { atribui }





procedure imprime;
var n : integer; {recebe a posicao do numeo que sera impresso}
begin
   read(n);
   writeln(numero[n][1]:0:3,' ',numero[n][2]:0:3);
end; { imprime }





procedure argumento;
var
   n   : integer; {recebe a posicao do numero do qual sera tirado o argumento}
   ang : real; { recebe o angulo da tangente b/a }
begin
   read(n);
   if (numero[n][1] = 0) and (numero[n][2] = 0) then
      writeln('Argumento indeterminado.')
   else begin

      ang:=arctan(abs(numero[n][2])/abs(numero[n][1]));


      if      (numero[n][1] > 0) and (numero[n][2] = 0) then
	 ang:=0
	 
      else if (numero[n][1] = 0) and (numero[n][2] > 0) then
	 ang:=pi/2

      else if (numero[n][1] < 0) and (numero[n][2] > 0) then
	 ang:=pi-ang

      else if (numero[n][1] < 0) and (numero[n][2] = 0) then
	 ang:=pi

      else if (numero[n][1] < 0) and (numero[n][2] < 0) then
	 ang:=pi+ang

      else if (numero[n][1] = 0) and (numero[n][2] < 0) then
	 ang:=3/2*pi

      else if (numero[n][1] > 0) and (numero[n][2] < 0) then
	 ang:=(2*pi) - ang;

      writeln(ang:0:3);
   end;
end; { argumento }





procedure modulo;
var n : integer; {recebe a posicao do numero do qual sera tirado o modulo}
begin
   read(n);
   writeln(sqrt(sqr(numero[n][1]) + sqr(numero[n][2])):0:3);
end; { modulo }





procedure soma(tipo	: integer); {tipo=1 --> soma, tipo=2 --> subtrai}
var n : array[1..3] of integer; {recebe as posicoes: [1] sera somado com [2] e atribuido em [3]}
begin
   read(n[1],n[2],n[3]);

   if (tipo=1) then begin
      numero[n[3]][1]:=numero[n[1]][1] + numero[n[2]][1];
      numero[n[3]][2]:=numero[n[1]][2] + numero[n[2]][2]
   end else begin
      numero[n[3]][1]:=numero[n[1]][1] - numero[n[2]][1];
      numero[n[3]][2]:=numero[n[1]][2] - numero[n[2]][2];
   end;
end; { soma }





procedure multiplica(tipo : integer); {tipo=1-->multiplica, tipo=2-->divide}
var n : array[1..3] of integer; {recebe as posicoes: [1] sera multiplicado com [2] e atribuido em [3]}
begin
   read(n[1],n[2],n[3]);

   if (tipo=1) then begin
      { (a+bi)*(c+di) = a*c - b*d  +(a*d + b*c)i }
      numero[n[3]][1]:=numero[n[1]][1] * numero[n[2]][1] - numero[n[1]][2] * numero[n[2]][2];
      numero[n[3]][2]:=numero[n[1]][1] * numero[n[2]][2] + numero[n[1]][2] * numero[n[2]][1];
   end else begin
      { (a+bi)/(c+di) = (a*c + b*d)/(c^2 + d^2)  + ( (b*c - a*d)/(c^2 + d^2) )i }
      numero[n[3]][1]:=(numero[n[1]][1] * numero[n[2]][1] + numero[n[1]][2] * numero[n[2]][2])/(sqr(numero[n[2]][1]) +  sqr(numero[n[2]][2]));
      numero[n[3]][2]:= (-1*numero[n[1]][1] * numero[n[2]][2] + numero[n[1]][2] * numero[n[2]][1])/(sqr(numero[n[2]][1]) +  sqr(numero[n[2]][2]));
   end;

   
end; { multiplica }





procedure conjugado;
var n : array[1..2] of integer; {recebe posicoes: [2] = conjugado de [1]}
begin
   read(n[1],n[2]);

   numero[n[2]][1]:=numero[n[1]][1];
   numero[n[2]][2]:=-1*numero[n[1]][2];
end; { conjugado }





procedure exponencia;
var n : array[1..2] of integer; {recebe posicoes: [2] = exponencial de [1]}
begin
   read(n[1],n[2]);
   {e^(a+bi) = e^a(cos(b) + sen(b)i)}
   numero[n[2]][1]:=exp(numero[n[1]][1])*cos(numero[n[1]][2]);
   numero[n[2]][2]:=exp(numero[n[1]][1])*sin(numero[n[1]][2]);
end; { exponencia }

 
	

{% Corpo principal %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%} 
begin 

   read(opcao);
   
   while opcao <> 'x' do begin
      case opcao of
	'=' : atribui;
	'p' : imprime;
	'a' : argumento;
	'|' : modulo;
	'+' : soma(1);
	'-' : soma(2);
	'*' : multiplica(1);
	'/' : multiplica(2);
	'!' : conjugado;
	'e' : exponencia;
      end; { case }
      read(opcao);
   end;
end.



