{Aluno: GUSTAVO SVERZUT BARBIERI            RA.: 008849}
{Prof.: Arnaldo                                        }
{------------------------------------------------------}
{Programa para treinar recursao.                       }
{Acha a saida para um labirinto                        }


{OBS: Prioridade: Leste, Norte, Oeste, Sul}

program labirinto;

const
   parede     = '*';
   corredor   = '.';
   percorrido = '?';
   errado     = '#';
   solucao    = '0';
   MAX_l      = 50;
   MAX_c      = 80;

type
   labirint = array[1..MAX_l,1..MAX_c] of char;
   position   = array[1..2] of integer;

var 
   entrada,saida : position;
   m,n		 : integer;
   labirinto	 : labirint;
   c		 : array[1..2] of integer;
   achou	 : boolean;
   
{%%%%% Procedimentos e Funcoes %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure ImprimeLabirinto;
var
   c : array[1..2] of integer;
begin
   for c[1]:=1 to m do begin
      for c[2]:=1 to n do
	 if ( (c[1]=entrada[1]) and (c[2]=entrada[2]) ) then
	    write('E')
	 else if ( (c[1]=saida[1]) and (c[2]=saida[2]) ) then
	    write('S')
	 else
	    if labirinto[c[1],c[2]] = errado then
	       write(corredor) { apaga marca de caminho errado }
	    else 
	       write(labirinto[c[1],c[2]]);
      writeln('');
      
   end;
   
end; { ImprimeLabirinto }

function AchaSaida(lin,col :integer ):boolean;
var
   achou : boolean;
begin 
   if (lin = saida[1]) and (col = saida[2]) then { Caso Base }
      AchaSaida:=true
   else begin
      labirinto[lin,col]:=percorrido;
      achou:=false;

      { Ordem: Direira(L), Cima(N), Esquerda(O), Baixo(S) }
      if      (labirinto[lin,col+1] = corredor) and (achou = false) then { A direita esta livre }
	 achou:=AchaSaida(lin,col+1);
	 
       if (labirinto[lin-1,col] = corredor) and (achou = false) then { Acima esta livre }
	 achou:=AchaSaida(lin-1,col);

       if (labirinto[lin,col-1] = corredor) and (achou = false) then { A esquerda esta livre }
	 achou:=AchaSaida(lin,col-1);

      if (labirinto[lin+1,col] = corredor) and (achou = false) then { Abaixo esta livre }
	 achou:=AchaSaida(lin+1,col);

      if achou then
	 labirinto[lin,col]:=solucao
      else
	 labirinto[lin,col]:=errado;

      AchaSaida:=achou;
   end;
end; { AchaSaida }


   
{%%%%% Corpo Principal %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
begin 
   readln(m,n); {Tamanho do labirinto}
   readln(entrada[1],entrada[2]); {Posicao da entrada}
   readln(saida[1],saida[2]); {Posicao da saida}

   {Le o labirinto}
   for c[1]:=1 to m do 
      for c[2]:=1 to n do
	 if (c[2] < n) then
	    read(labirinto[c[1],c[2]])
	 else
	    readln(labirinto[c[1],c[2]]); { Senao ele le o \n como proximo caractere }

   achou:=AchaSaida(entrada[1],entrada[2]);

   if achou then 
      ImprimeLabirinto
   else 
      writeln('Labirinto sem saida.');
   
end.






